/*
 * name SorobanEmu.pde
 * date Sat Mar 09 09:23:35 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int         A0 =   0;  // Slider:INPUT

void setup() {	// 一番最初に呼ばれる関数
  // 個人的な趣味で，そろばん珠の動きをテストするために作成しました。
  // arduinoのPin配置とは全く異なる使い方なので，参考にしないでください。
  initComponents();
}

void loop() {	// 1/60秒ごとに自動実行
  int value;
  value = analogRead(A0);
   drawSoroban4(value / 1000);
   drawSoroban3((value % 1000) / 100);
   drawSoroban2((value %  100) /  10);
   drawSoroban1( value %   10);
   delay(250);               // wait for a second
}

void drawSoroban4(int n) {
  if ((n / 5) > 0) digitalWrite(45, HIGH); 
  else             digitalWrite(45, LOW );

  switch (n % 5) {
    case  4 : digitalWrite(41, HIGH);
              digitalWrite(42, HIGH);
              digitalWrite(43, HIGH);
              digitalWrite(44, HIGH); break;
    case  3 : digitalWrite(41, HIGH);
              digitalWrite(42, HIGH);
              digitalWrite(43, HIGH);
              digitalWrite(44, LOW ); break;
    case  2 : digitalWrite(41, HIGH);
              digitalWrite(42, HIGH);
              digitalWrite(43, LOW );
              digitalWrite(44, LOW ); break;
    case  1 : digitalWrite(41, HIGH);
              digitalWrite(42, LOW );
              digitalWrite(43, LOW );
              digitalWrite(44, LOW ); break;
    case  0 : digitalWrite(41, LOW );
              digitalWrite(42, LOW );
              digitalWrite(43, LOW );
              digitalWrite(44, LOW ); break;    
  }
}

void drawSoroban3(int n) {
  if ((n / 5) > 0) digitalWrite(35, HIGH); 
  else             digitalWrite(35, LOW );

  switch (n % 5) {
    case  4 : digitalWrite(31, HIGH);
              digitalWrite(32, HIGH);
              digitalWrite(33, HIGH);
              digitalWrite(34, HIGH); break;
    case  3 : digitalWrite(31, HIGH);
              digitalWrite(32, HIGH);
              digitalWrite(33, HIGH);
              digitalWrite(34, LOW ); break;
    case  2 : digitalWrite(31, HIGH);
              digitalWrite(32, HIGH);
              digitalWrite(33, LOW );
              digitalWrite(34, LOW ); break;
    case  1 : digitalWrite(31, HIGH);
              digitalWrite(32, LOW );
              digitalWrite(33, LOW );
              digitalWrite(34, LOW ); break;
    case  0 : digitalWrite(31, LOW );
              digitalWrite(32, LOW );
              digitalWrite(33, LOW );
              digitalWrite(34, LOW ); break;    
  }
}

void drawSoroban2(int n) {
  if ((n / 5) > 0) digitalWrite(25, HIGH); 
  else             digitalWrite(25, LOW );

  switch (n % 5) {
    case  4 : digitalWrite(21, HIGH);
              digitalWrite(22, HIGH);
              digitalWrite(23, HIGH);
              digitalWrite(24, HIGH); break;
    case  3 : digitalWrite(21, HIGH);
              digitalWrite(22, HIGH);
              digitalWrite(23, HIGH);
              digitalWrite(24, LOW ); break;
    case  2 : digitalWrite(21, HIGH);
              digitalWrite(22, HIGH);
              digitalWrite(23, LOW );
              digitalWrite(24, LOW ); break;
    case  1 : digitalWrite(21, HIGH);
              digitalWrite(22, LOW );
              digitalWrite(23, LOW );
              digitalWrite(24, LOW ); break;
    case  0 : digitalWrite(21, LOW );
              digitalWrite(22, LOW );
              digitalWrite(23, LOW );
              digitalWrite(24, LOW ); break;    
  }
}

void drawSoroban1(int n) {
  if ((n / 5) > 0) digitalWrite(15, HIGH); 
  else             digitalWrite(15, LOW );

  switch (n % 5) {
    case  4 : digitalWrite(11, HIGH);
              digitalWrite(12, HIGH);
              digitalWrite(13, HIGH);
              digitalWrite(14, HIGH); break;
    case  3 : digitalWrite(11, HIGH);
              digitalWrite(12, HIGH);
              digitalWrite(13, HIGH);
              digitalWrite(14, LOW ); break;
    case  2 : digitalWrite(11, HIGH);
              digitalWrite(12, HIGH);
              digitalWrite(13, LOW );
              digitalWrite(14, LOW ); break;
    case  1 : digitalWrite(11, HIGH);
              digitalWrite(12, LOW );
              digitalWrite(13, LOW );
              digitalWrite(14, LOW ); break;
    case  0 : digitalWrite(11, LOW );
              digitalWrite(12, LOW );
              digitalWrite(13, LOW );
              digitalWrite(14, LOW ); break;    
  }
}

void draw() {
  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// digital OUTPUT
void digitalWrite(int outPin, int value) {
    switch (outPin) {
        case 45 : led4_5.setState(value); break;
        case 41 : led4_1.setState(value); break;
        case 42 : led4_2.setState(value); break;
        case 43 : led4_3.setState(value); break;
        case 44 : led4_4.setState(value); break;

        case 35 : led3_5.setState(value); break;
        case 31 : led3_1.setState(value); break;
        case 32 : led3_2.setState(value); break;
        case 33 : led3_3.setState(value); break;
        case 34 : led3_4.setState(value); break;

        case 25 : led2_5.setState(value); break;
        case 21 : led2_1.setState(value); break;
        case 22 : led2_2.setState(value); break;
        case 23 : led2_3.setState(value); break;
        case 24 : led2_4.setState(value); break;

        case 15 : led1_5.setState(value); break;
        case 11 : led1_1.setState(value); break;
        case 12 : led1_2.setState(value); break;
        case 13 : led1_3.setState(value); break;
        case 14 : led1_4.setState(value); break;
    }
}
// analog INPUT
int analogRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case   0 : value = slider0.getValue(); break;
    }
    return value;
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;
  // digital
      led4_5 = new Led(45 , "red",    0,    0);
      led4_1 = new Led(41 , "red",    0,  160);
      led4_2 = new Led(42 , "red",    0,  288);
      led4_3 = new Led(43 , "red",    0,  416);
      led4_4 = new Led(44 , "red",    0,  544);
                       
      led3_5 = new Led(35 , "red",  120,    0);
      led3_1 = new Led(31 , "red",  120,  160);
      led3_2 = new Led(32 , "red",  120,  288);
      led3_3 = new Led(33 , "red",  120,  416);
      led3_4 = new Led(34 , "red",  120,  544);
                       
      led2_5 = new Led(25 , "red",  240,    0);
      led2_1 = new Led(21 , "red",  240,  160);
      led2_2 = new Led(22 , "red",  240,  288);
      led2_3 = new Led(23 , "red",  240,  416);
      led2_4 = new Led(24 , "red",  240,  544);
                       
      led1_5 = new Led(15 , "red",  360,    0);
      led1_1 = new Led(11 , "red",  360,  160);
      led1_2 = new Led(12 , "red",  360,  288);
      led1_3 = new Led(13 , "red",  360,  416);
      led1_4 = new Led(14 , "red",  360,  544);

     slider0 = new Slider(0 , "INPUT0",  512,    0, javax.swing.JSlider.VERTICAL  );
  

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  // wave = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  wave = new ddf.minim.signals.SquareWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  wave.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(wave);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

// private static final int A0     = 0x0;
// private static final int A1     = 0x1;
// private static final int A2     = 0x2;
// private static final int A3     = 0x3;
// private static final int A4     = 0x4;
// private static final int A5     = 0x5;
// private static final int A6     = 0x6;
// private static final int A7     = 0x7;
// private static final int A8     = 0x8;
// private static final int A9     = 0x9;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
// private ddf.minim.signals.SawWave      wave; // A saw wave is characterized by rising edge followed by a sharp drop off.
// private ddf.minim.signals.SineWave     wave; // A sine wave is a smooth curve that oscillates between -1 and 1.
private ddf.minim.signals.SquareWave   wave; // A square wave alternates between 1 and -1 at regular intervals.
// private ddf.minim.signals.TriangleWave wave; // A triangle wave oscillates between 1 and -1 following a straight line.

private Led led4_5;
private Led led4_1;
private Led led4_2;
private Led led4_3;
private Led led4_4;

private Led led3_5;
private Led led3_1;
private Led led3_2;
private Led led3_3;
private Led led3_4;

private Led led2_5;
private Led led2_1;
private Led led2_2;
private Led led2_3;
private Led led2_4;

private Led led1_5;
private Led led1_1;
private Led led1_2;
private Led led1_3;
private Led led1_4;

private Slider slider0;


// End of variables declaration//GEN-END:variables


