/*
 * name toneKeyboard.pde
 * date Sun Feb 10 12:30:41 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int      key5C =   2;  // Switch:Push
int      key5D =   3;  // Switch:Push
int      key5E =   4;  // Switch:Push
int      key5F =   5;  // Switch:Push
int      key5G =   6;  // Switch:Push
int      key5A =   7;  // Switch:Push
int      key5B =   8;  // Switch:Push
int      key6C =   9;  // Switch:Push
int    speaker =  10;  // Speaker:

int       freq = 0;

void setup() {	// 一番最初に呼ばれる関数
  // slider 2-9の値を読取り，それぞれに割り当てられた音階を再生します。
  initComponents();
  // initialize
     pinMode(key5C,  INPUT);  // Switch:Push
     pinMode(key5D,  INPUT);  // Switch:Push
     pinMode(key5E,  INPUT);  // Switch:Push
     pinMode(key5F,  INPUT);  // Switch:Push
     pinMode(key5G,  INPUT);  // Switch:Push
     pinMode(key5A,  INPUT);  // Switch:Push
     pinMode(key5B,  INPUT);  // Switch:Push
     pinMode(key6C,  INPUT);  // Switch:Push
     pinMode(speaker, OUTPUT);  // Speaker:
// pinMode(13, OUTPUT);
}

void loop() {	// 1/60秒ごとに自動実行
  freq = 0;
  if (HIGH == digitalRead(key5C)) freq =  528;
  if (HIGH == digitalRead(key5D)) freq =  594;
  if (HIGH == digitalRead(key5E)) freq =  660;
  if (HIGH == digitalRead(key5F)) freq =  704;
  if (HIGH == digitalRead(key5G)) freq =  792;
  if (HIGH == digitalRead(key5A)) freq =  880;
  if (HIGH == digitalRead(key5B)) freq =  990;
  if (HIGH == digitalRead(key6C)) freq = 1056;
/**********************************************
  if (HIGH == digitalRead(key4C)) freq =  440;
  if (HIGH == digitalRead(key4D)) freq =  495;
  if (HIGH == digitalRead(key4E)) freq =  264;
  if (HIGH == digitalRead(key4F)) freq =  297;
  if (HIGH == digitalRead(key4G)) freq =  330;
  if (HIGH == digitalRead(key4A)) freq =  352;
  if (HIGH == digitalRead(key4B)) freq =  396;
  if (HIGH == digitalRead(key5C)) freq =  528;
 **********************************************/
  
  if (0 != freq) { 
     tone(speaker, freq, 200);
  }
  delay(200);               // wait for a second
}

void draw() {

  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// digital INPUT
int digitalRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case 2 : value = switch2.isState(); break;
        case 3 : value = switch3.isState(); break;
        case 4 : value = switch4.isState(); break;
        case 5 : value = switch5.isState(); break;
        case 6 : value = switch6.isState(); break;
        case 7 : value = switch7.isState(); break;
        case 8 : value = switch8.isState(); break;
        case 9 : value = switch9.isState(); break;
    }
    return value;
}
// Speakerで使用する関数群

void tone(int pin, int frequency) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  speaker10.setFrequency(frequency);
  wave.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
}

void tone(int pin, int frequency, long duration) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  wave.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
  TimerTaskAudioStop timerTask = new TimerTaskAudioStop(); //タイマータスクインスタンス作成
  //タイマー開始
  DelayTimer.schedule(timerTask, duration);
}

void noTone(int pin) {
  ToneFlag = 0;
  speaker10.setFrequency(0);
  auOut.mute();
  auOut.noSound();
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
                   switch2 = new Switch(2 , "Push2",    0,  240);
                   switch3 = new Switch(3 , "Push3",  120,  240);
                   switch4 = new Switch(4 , "Push4",  240,  240);
                   switch5 = new Switch(5 , "Push5",  360,  240);
                   switch6 = new Switch(6 , "Push6",  480,  240);
                   switch7 = new Switch(7 , "Push7",  600,  240);
                   switch8 = new Switch(8 , "Push8",  720,  240);
                   switch9 = new Switch(9 , "Push9",  840,  240);
                 speaker10 = new Speaker(10 , "speaker10",   0,    0);
  

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  // wave = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  wave = new ddf.minim.signals.SquareWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  wave.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(wave);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

// private static final int A0     = 0x0;
// private static final int A1     = 0x1;
// private static final int A2     = 0x2;
// private static final int A3     = 0x3;
// private static final int A4     = 0x4;
// private static final int A5     = 0x5;
// private static final int A6     = 0x6;
// private static final int A7     = 0x7;
// private static final int A8     = 0x8;
// private static final int A9     = 0x9;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
// private ddf.minim.signals.SawWave      wave; // A saw wave is characterized by rising edge followed by a sharp drop off.
// private ddf.minim.signals.SineWave     wave; // A sine wave is a smooth curve that oscillates between -1 and 1.
private ddf.minim.signals.SquareWave   wave; // A square wave alternates between 1 and -1 at regular intervals.
// private ddf.minim.signals.TriangleWave wave; // A triangle wave oscillates between 1 and -1 following a straight line.

private Switch switch2;
private Switch switch3;
private Switch switch4;
private Switch switch5;
private Switch switch6;
private Switch switch7;
private Switch switch8;
private Switch switch9;
private Speaker speaker10;
// End of variables declaration//GEN-END:variables

