/*
 * name tuner.pde
 * date Mon Dec 23 23:05:58 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int         D2 =   2;  // Switch:Push
int        D10 =  10;  // Speaker:

int   S0 =   0;  // Serial
int   S1 =   1;  // Serial
int  S19 =  19;  // NixieTube
int  S18 =  18;  // NixieTube

int    analog0 =   0;  // Slider:INPUT
int    analog1 =   0;  // Slider:INPUT
int    analog2 =   0;  // Slider:INPUT
int    analog3 =   0;  // Slider:INPUT

int value0 = 0;
int value1 = 0; 
int value2 = 0;
int value3 = 0;

int    freq = 0;

void setup() {	// 一番最初に呼ばれる関数
// tuner
// 楽器を調律するためのチューナーです。
// D2 ボタンを押すと、Nixie管に表示されている周波数の音を再生します。
// 周波数の設定は、スライダー0-3で行います。

  initComponents();
  // initialize
     pinMode(D2,  INPUT);  // Switch:Push
     pinMode(D10, OUTPUT);  // Speaker:
// pinMode(13, OUTPUT);
}

void loop() {	// 1/60秒ごとに自動実行
        analog0 = analogRead(A0); if (analog0 >  800) analog0 = 800;
        analog1 = analogRead(A1); if (analog1 > 1000) analog1 = 999;
        analog2 = analogRead(A2); if (analog2 > 1000) analog2 = 999;
        analog3 = analogRead(A3); if (analog3 > 1000) analog3 = 999;

        value0 = analog0 / 100; 
        value1 = analog1 / 100; 
        value2 = analog2 / 100; 
        value3 = analog3 / 100; 
 
       dispNixie1(0, value0);
       dispNixie1(1, value1);
       dispNixie1(2, value2);
       dispNixie1(3, value3);

  int sw = digitalRead(D2);
  if (sw == HIGH) {
      Serial.println(value0 + " " + value1 + " " + value2 + " " + value3 + " Hz");
      freq = value0 * 1000 + 
                 value1 *  100 + 
                 value2 *   10 + 
                 value3;     
       tone(D10, freq, 200);
      delay(200);               // wait for 200 ms
     noTone(D10);
   } else {
     delay(200);
   }
}

void draw() {
  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// digital INPUT
int digitalRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case 2 : value = switch2.isState(); break;
    }
    return value;
}
// analog OUTPUT
void analogWrite(int inPin, int value) {
    switch (inPin) {
        case 0 : slider0.setValue(value);
                  break;
        case 1 : slider1.setValue(value);
                  break;
        case 2 : slider2.setValue(value);
                  break;
        case 3 : slider3.setValue(value);
                  break;
    }
}

// analog INPUT
int analogRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case   0 : value = slider0.getValue(); break;
        case   1 : value = slider1.getValue(); break;
        case   2 : value = slider2.getValue(); break;
        case   3 : value = slider3.getValue(); break;
    }
    return value;
}



// Speakerで使用する関数群

void tone(int pin, int frequency) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  speaker10.setFrequency(frequency);
  wave.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
}

void tone(int pin, int frequency, long duration) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  wave.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
  TimerTaskAudioStop timerTask = new TimerTaskAudioStop(); //タイマータスクインスタンス作成
  //タイマー開始
  DelayTimer.schedule(timerTask, duration);
}

void noTone(int pin) {
  ToneFlag = 0;
  speaker10.setFrequency(0);
  auOut.mute();
  auOut.noSound();
}
// Nixie tube
void dispNixie1(int n, int value) {
  // n     : Nixie number  0 - 3
  // value : 0 - 9
  switch (n) {
    case  0 : nixie1[0].setValue(value); break;
    case  1 : nixie1[1].setValue(value); break;
    case  2 : nixie1[2].setValue(value); break;
    case  3 : nixie1[3].setValue(value); break;
  }
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
                   switch2 = new Switch(2 , "Push2",  672,    460);
                 speaker10 = new Speaker(10 , "speaker10",  840,  460);
                   slider0 = new Slider(0 , "OUTPUT0",    0,  460, javax.swing.JSlider.VERTICAL);
                   slider0.setSize(120, 280);
                   slider1 = new Slider(1 , "OUTPUT1",  168,  460, javax.swing.JSlider.VERTICAL);
                   slider1.setSize(120, 280);
                   slider2 = new Slider(2 , "OUTPUT2",  336,  460, javax.swing.JSlider.VERTICAL);
                   slider2.setSize(120, 280);
                   slider3 = new Slider(3 , "OUTPUT3",  504,  460, javax.swing.JSlider.VERTICAL);
                   slider3.setSize(120, 280);
  Serial = new SerialConsole(680, 0);
    nixie1 = new NixieTube[4];
  for (int r = 0; r < 1;   r++) {
    for (int c = 0; c < 4; c++) {
      int i = (r * c) + c;
      String nixie_num = "Nixie " + Integer.valueOf(i).toString();
      nixie1[i] = new NixieTube(i , nixie_num, 0 + c * 168, 0 + r * 460);
    }
  }

  

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  // wave = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  wave = new ddf.minim.signals.SquareWave(440, 0.5, auOut.sampleRate()); 
  // set the portamento speed on the oscillator to 200 milliseconds
  wave.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(wave);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

 private static final int A0     = 0x0;
 private static final int A1     = 0x1;
 private static final int A2     = 0x2;
 private static final int A3     = 0x3;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
// private ddf.minim.signals.SawWave      wave; // A saw wave is characterized by rising edge followed by a sharp drop off.
// private ddf.minim.signals.SineWave     wave; // A sine wave is a smooth curve that oscillates between -1 and 1.
private ddf.minim.signals.SquareWave   wave; // A square wave alternates between 1 and -1 at regular intervals.
// private ddf.minim.signals.TriangleWave wave; // A triangle wave oscillates between 1 and -1 following a straight line.

private Switch switch2;
private Speaker speaker10;
private Slider slider0;
private Slider slider1;
private Slider slider2;
private Slider slider3;
private SerialConsole Serial;
private NixieTube[] nixie1;


// End of variables declaration//GEN-END:variables


