/*
 * name Tutorial05.pde
 * date Sun Mar 31 14:33:53 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int AIN0 =   0;  // Slider:INPUT:HORIZONTAL
int   S0 =   0;  // Serial
int   S1 =   1;  // Serial
int  S19 =  19;  // SevenSegmentDisplay
int  S18 =  18;  // SevenSegmentDisplay
int  S17 =  17;  // NixieTube
int  S16 =  16;  // NixieTube
int  S15 =  15;  // Lcd1602
int  S14 =  14;  // Lcd1602

void setup() {	// 一番最初に呼ばれる関数
// スライダー0から値を読み取って，LCDにその値を表示します。
// また，シリアルコンソールにも同じ値を表示します。
// 課題:スライダー0から読み取った値を4桁の7segLEDに表示せよ。
//      同様に，4桁のニキシー管にも値を表示せよ。
  initComponents();
  // initialize
}

void loop() {	// 1/60秒ごとに自動実行
  int value;                        // アナログポートから読み込んだ値を保存します。0-1023
  value = analogRead(AIN0);         // アナログポート1の値を読み込みます。
  Serial.print("value = ");         // シリアルコンソールへの情報表示
  Serial.println(value);

  disp7SEG1(2,                 0 ); //            0を7segLEDの2桁目に表示
  disp7SEG1(3,  (int)(value % 10)); // 読み込んだ値の1桁目を7segLEDに表示

  dispNixie2(2,                0 ); //            0をニキシー管の2桁目に表示
  dispNixie2(3, (int)(value % 10)); // 読み込んだ値の1桁目をニキシー管に表示

  lcd3.print(0, "Slider In 0");
  lcd3.print(1, "[" + value + "]"); // valueの値をLCDに表示します。
  delay(500);                       // 500ms間の時間待ち
}

void draw() {
  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// analog INPUT
int analogRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case   0 : value = slider0.getValue(); break;
    }
    return value;
}
// Seven Segment Display
void disp7SEG1(int n, int value) {
  // n     : 7seg number  0 - 3
  // value : 0 - 15
  switch (n) {
    case  0 : ssd1[0].setValue(value); break;
    case  1 : ssd1[1].setValue(value); break;
    case  2 : ssd1[2].setValue(value); break;
    case  3 : ssd1[3].setValue(value); break;
  }
}
// Nixie tube
void dispNixie2(int n, int value) {
  // n     : Nixie number  0 - 3
  // value : 0 - 9
  switch (n) {
    case  0 : nixie2[0].setValue(value); break;
    case  1 : nixie2[1].setValue(value); break;
    case  2 : nixie2[2].setValue(value); break;
    case  3 : nixie2[3].setValue(value); break;
  }
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
                   slider0 = new Slider(0 , "INPUT0",    0,    0, javax.swing.JSlider.HORIZONTAL);
                   slider0.setSize(384, 120);
  Serial = new SerialConsole(0, 120);
    ssd1 = new SevenSegmentDisplay[4];
  for (int r = 0; r < 1;    r++) {
    for (int c = 0; c < 4; c++) {
      int i = (r * c) + c;
      String ssd_num = "SSD " + Integer.valueOf(i).toString();
      ssd1[i] = new SevenSegmentDisplay(i , ssd_num, 420 + c * 144, 0 + r * 264);
    }
  }

    nixie2 = new NixieTube[4];
  for (int r = 0; r < 1;   r++) {
    for (int c = 0; c < 4; c++) {
      int i = (r * c) + c;
      String nixie_num = "Nixie " + Integer.valueOf(i).toString();
      nixie2[i] = new NixieTube(i , nixie_num, 420 + c * 168, 280 + r * 460);
    }
  }

  lcd3 = new Lcd(3 , 0, 480, 1602);
  

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  // wave = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  wave = new ddf.minim.signals.SquareWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  wave.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(wave);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
// private ddf.minim.signals.SawWave      wave; // A saw wave is characterized by rising edge followed by a sharp drop off.
// private ddf.minim.signals.SineWave     wave; // A sine wave is a smooth curve that oscillates between -1 and 1.
private ddf.minim.signals.SquareWave   wave; // A square wave alternates between 1 and -1 at regular intervals.
// private ddf.minim.signals.TriangleWave wave; // A triangle wave oscillates between 1 and -1 following a straight line.

private Slider slider0;
private SerialConsole Serial;
private SevenSegmentDisplay[] ssd1;
private NixieTube[] nixie2;
private Lcd lcd3;


// End of variables declaration//GEN-END:variables


